
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_buffers 4
#property indicator_color1 Green 
#property indicator_color2 Blue 
#property indicator_color3 Gold 
#property indicator_color4 Red  

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern bool   GreenColorAlerts = true;
extern bool   BlueColorAlerts  = false;
extern bool   GoldColorAlerts  = false;
extern bool   RedColorAlerts   = true;
extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsNotify     = true;
extern bool   alertsEmail      = false;
extern string soundFile        = "alert2.wav";

//---- indicator buffers
double dMFIBuffer[];
double dMFIUpVUpBuffer[]; //  
double dMFIDownVDownBuffer[]; // 
double dMFIUpVDownBuffer[]; // 
double dMFIDownVUpBuffer[]; //  
double trend1[];
double trend2[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   IndicatorBuffers(7);
   SetIndexBuffer(0,dMFIUpVUpBuffer);     SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dMFIDownVDownBuffer); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,dMFIUpVDownBuffer);   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,dMFIDownVUpBuffer);   SetIndexStyle(3,DRAW_HISTOGRAM); 
   SetIndexBuffer(4,dMFIBuffer);
   SetIndexBuffer(5,trend1); 
   SetIndexBuffer(6,trend2);
   
       //
       //
       //
       //
       //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
       
       //
       //
       //
       //
       // 

       IndicatorShortName(timeFrameToString(timeFrame)+"  BW MFI + Volumes");  
       SetIndexLabel(0,"");
       SetIndexLabel(1,"");
       SetIndexLabel(2,"");
       SetIndexLabel(3,"");
return(0);
}

//+------------------------------------------------------------------+
//| BW Market Facilitation Index                                     |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-1,Bars-counted_bars-1);
           if (returnBars) { dMFIUpVUpBuffer[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
     for (i = limit; i >= 0; i--)
     {
        if(i==0 && Volume[i]<Period()*1.5) dMFIBuffer[i] = 0.0;
        else                               dMFIBuffer[i] = (High[i]-Low[i])/(Volume[i]*Point);
     } 
     for (i = limit; i >= 0; i--)
     {
        dMFIUpVUpBuffer[i]     = EMPTY_VALUE;
        dMFIDownVDownBuffer[i] = EMPTY_VALUE;
        dMFIUpVDownBuffer[i]   = EMPTY_VALUE;
        dMFIDownVUpBuffer[i]   = EMPTY_VALUE;
        trend1[i] = 0;
        trend2[i] = 0; 
      
        //
        //
        //
        //
        //
      
        if (dMFIBuffer[i]>dMFIBuffer[i+1] && Volume[i]>Volume[i+1]) trend1[i] = 1;
        if (dMFIBuffer[i]<dMFIBuffer[i+1] && Volume[i]<Volume[i+1]) trend1[i] =-1;
        if (dMFIBuffer[i]>dMFIBuffer[i+1] && Volume[i]<Volume[i+1]) trend2[i] = 1;
        if (dMFIBuffer[i]<dMFIBuffer[i+1] && Volume[i]>Volume[i+1]) trend2[i] =-1;
        if (trend1[i] == 1) dMFIUpVUpBuffer[i]     = Volume[i];
        if (trend1[i] ==-1) dMFIDownVDownBuffer[i] = Volume[i];
        if (trend2[i] == 1) dMFIUpVDownBuffer[i]   = Volume[i];
        if (trend2[i] ==-1) dMFIDownVUpBuffer[i]   = Volume[i];             
      }                     
   manageAlerts(); 
   return(0);
   }
  
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         dMFIUpVUpBuffer[i]     = EMPTY_VALUE;
         dMFIDownVDownBuffer[i] = EMPTY_VALUE;
         dMFIUpVDownBuffer[i]   = EMPTY_VALUE;
         dMFIDownVUpBuffer[i]   = EMPTY_VALUE;
         trend1[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",5,y); 
         trend2[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",6,y); 
         if (trend1[i] == 1) dMFIUpVUpBuffer[i]     = Volume[i];
         if (trend1[i] ==-1) dMFIDownVDownBuffer[i] = Volume[i];
         if (trend2[i] == 1) dMFIUpVDownBuffer[i]   = Volume[i];
         if (trend2[i] ==-1) dMFIDownVUpBuffer[i]   = Volume[i];  
    }
   manageAlerts();    
return(0);
}    

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      
      if (trend1[whichBar] != trend1[whichBar+1] || trend2[whichBar] != trend2[whichBar+1])
      {
         if (trend1[whichBar] == 1 && GreenColorAlerts) doAlert(whichBar,"Green Color signal");
         if (trend1[whichBar] ==-1 && BlueColorAlerts)  doAlert(whichBar,"Blue Color signal");
         if (trend2[whichBar] == 1 && GoldColorAlerts)  doAlert(whichBar,"Gold Color signal");
         if (trend2[whichBar] ==-1 && RedColorAlerts)   doAlert(whichBar,"Red Color signal");
      }                
   }
}   
   
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",timeFrameToString(Period())+" BW MFI+Volumes ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," BW MFI+Volumes " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," BW MFI+Volumes "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
 

